config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  root to: 'home#index'
  # Genera las rutas
  resources :employees, except: [:show]
  resources :records
  resources :search
  resources :profiles, only: [:show, :edit, :update]
  resources :documents

  get 'report', to: 'reports#report'
  post 'report', to: 'reports#report'

  get 'export', to: 'reports#export'
  post 'export', to: 'reports#export'

  get 'searchInCalendar', to: 'search#calendar'
  post 'searchInCalendar', to: 'search#calendar'

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/controllers/reports_controller.rb
class ReportsController < ApplicationController
    
    def report
        @employee = Employee.select("*, nombre || ', ' || apellido AS nombre_completo").all
    end

    def export
        @date_range = params[:date_range]
        @employee_id = params[:employee_id].to_i
        @registers = Record.where("employee_id = #{@employee_id} AND job_entry LIKE '%#{@date_range.to_s}%'").order(:job_entry)

        nombre = @registers.first ? @registers.first.employee.nombre : ""
        apellido = @registers.first ? @registers.first.employee.apellido : ""
        nombre_completo = nombre + ' ' + apellido
        extension = request.format.symbol
        file = nil

        name_file = "#{@employee_id}_#{nombre_completo}_#{@date_range}.#{extension}"

        if extension = "csv"
            file = @registers.to_csv(params[:employee_id], params[:date_range])
        else
           template = "reports/export.#{extension}"
           layout   = extension == "html"
           file = StringIO.new(render_to_string(template: template,layout: layout, formats: [extension], locals: { :@registers => @registers }))
        end

        #documents = Document.all

        if params[:export].nil?
            @document = Document.find_or_initialize_by(:name_file => name_file)
            @document.file.attach(io: StringIO.new(file), filename: name_file)
            @document.save
        end

        #if documents.length == 0
        #    @document = Document.new(name_file: name_file)
        #    @document.file.attach(io: StringIO.new(file), filename: name_file)
        #    @document.save
        #
        #else
        #    documents.first.destroy
        #    @document = Document.new(name_file: name_file)
        #    @document.file.attach(io: StringIO.new(file), filename: name_file)
        #    @document.save
        #end

        respond_to do |format|
            format.html
            format.csv {send_data file, filename: name_file}
            format.xls
        end
    end
end

app/views/reports/export.html.erb
<div class="container">
    <div class="row">
        <div class="col-md-8">
            <% reg = @registers.first %>
            <hr><h3><%= reg ? reg.employee.nombre + " " + reg.employee.apellido : "No hay registro de horarios" %></h3><hr>
            <table class="table table-bordered" id="tablaRegistros" width="100%" cellspacing="0">
                <thead>
                    <tr>
                        <th>Fecha</th>
                        <th>Entrada</th>
                        <th>Salida</th>
                        <th>Horas</th>
                    </tr>
                </thead>
                <tbody>
                    <% horas_al_mes = 0 %>
                    <% @registers.each do |reg| %>
                    <tr>
                        <td><%= reg.job_entry.strftime("%d - %m - %Y") %></td>
                        <td><%= reg.job_entry.strftime("%I:%M:%S %p") %></td>
                        <td><%= reg.job_exit ? reg.job_exit.strftime("%I:%M:%S %p") : "Sigue trabajando" %></td>
                        <td><%= reg.daily_hours ? reg.daily_hours.round(2).to_s + " Horas" : "" %></td>
                        <% horas_al_mes = horas_al_mes + reg.daily_hours.to_f %>
                    </tr>
                    <% end %>
                </tbody>
            </table>
        </div>

        <div class="col-md-4"><hr>
            
            <% if @registers.length > 0 %>
                <div class="col-md-12">
                    <h3 class = "text-center">Total de horas : <%= horas_al_mes.round(2) %></h3>
                </div>
            <% else %>
                <h3 class = "text-center">No hay horas</h3>
            <% end %>
            <hr><hr>
            <div class="col-md-12 text-center">
                <% if @registers.length > 0 %>
                
                    <div class="col-md-12">
                        <h4>Descargar Reporte:</h4>
                    </div>
                    <h4>
                        <%= link_to "CSV", export_path(:employee_id => @employee_id, :date_range => params[:date_range], format: :csv) %> |
                        <%= link_to "XLS", export_path(:employee_id => @employee_id, :date_range => params[:date_range], format: :xls) %> |
                        <%= link_to "HTML", export_path(:employee_id => @employee_id, :date_range => params[:date_range]), :download => 'Reporte_Horario' %>
                    </h4>
                    
                <% else %>
                    
                    <h4>No hay reportes para descargar</h4>

                <% end %>
            </div>
        </div>
    </div>    
</div>

app/views/reports/export.xls.erb
<?xml version="1.0"?>
<Workbook xmlns="urn:schemas-microsoft-com:office:spreadsheet"
  xmlns:o="urn:schemas-microsoft-com:office:office"
  xmlns:x="urn:schemas-microsoft-com:office:excel"
  xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet"
  xmlns:html="http://www.w3.org/TR/REC-html40">
  <% reg = @registers.first %>
  <Worksheet ss:Name="Reporte horarios de <%= reg.employee.nombre%>">
    <Table>
      <Row><Cell><Data ss:Type="String">Nombre Completo</Data></Cell></Row>
      <Row><Cell><Data ss:Type="String"><%= reg.employee.nombre + ", " + reg.employee.apellido %></Data></Cell></Row>
      <Row><Cell></Cell></Row>
      <Row>
        <Cell><Data ss:Type="String">Fecha</Data></Cell>
        <Cell><Data ss:Type="String">Entrada</Data></Cell>
        <Cell><Data ss:Type="String">Salida</Data></Cell>
        <Cell><Data ss:Type="String">Sub total de Horas</Data></Cell>
      </Row>
    <% horas_mes = 0 %>
    <% @registers.each do |record| %>
      <Row>
        <Cell><Data ss:Type="String"><%= record.job_entry.strftime("%d-%m-%Y") %></Data></Cell>
        <Cell><Data ss:Type="String"><%= record.job_entry.strftime("%I:%M:%S %p") %></Data></Cell>
        <Cell><Data ss:Type="String"><%= record.job_exit ? record.job_exit.strftime("%I:%M:%S %p") : "Sigue trabajando" %></Data></Cell>
        <Cell><Data ss:Type="String"><%= record.daily_hours ? record.daily_hours.round(2) : "Falta hora de salida para calcular horas." %></Data></Cell>
      </Row>
      <% horas_mes = horas_mes + record.daily_hours.to_f %>
    <% end %>
      <Row><Cell></Cell></Row>
      <Row><Cell><Data ss:Type="String">Total de Horas = <%= horas_mes.round(2) %></Data></Cell></Row>
    </Table>
  </Worksheet>
</Workbook>

app/views/reports/report.html.erb
<div class="container">
    <div class="row">
        <div class="col-md-3"></div>
        <div class="card shadow col-md-6">
            <div class="form-group">
                <div class="card-header">
                    <h2>Generar Reportes</h2>
                </div>
            </div>
            <div class="container">
                <div class="col-md-12">
                    <div class="card-body">
                    <%= form_tag export_path, method: :get do %>
                        <div class="form-group mb-3">
                            <%= label :employee_id, "Seleccionar empleado" %>
                            <%= select_tag :employee_id, options_from_collection_for_select(@employee, "id", "nombre_completo", params[:employee_id]), html_options = {class: "form-control"} %>
                        </div>
                        <div class="form-group mb-3">
                            <%= label :date_range, "Seleccionar el mes y año" %>
                            <%= month_field_tag :date_range, options = {}, html_options = { class: "form-control" } %>
                        </div>
                        <%= hidden_field(:export, :ignore_save, :value => 1) %>
                        <div class="form-group w-50">
                            <%= submit_tag(value = "Buscar", options = { class: "btn btn-dark" }) %>
                        </div>
                    <% end %>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>